# Ruby Password management tool
# author @tukapai
# mail: masashi1029xxx@gmail.com
require 'securerandom'
require 'json'
require 'clipboard'
require 'rbpw/pw_data'
require 'redic'

def read_from_db(key)
  db = Redic.new
  value = JSON.parse(db.call("GET", key))
  data = PwData.new
  data.key = key
  data.set_username(value["username"])
  data.set_password(value["password"])
  data
end

def save_to_db(data)
  db = Redic.new
  value = data.get_json_value
  db.call("SET", data.key.to_s, value) #Redic is not support HASHSET
  db.quit
end

def set_data(key, username, password)
  data = PwData.new
  data.key = key
  data.set_username(username)
  data.set_password(password)
  data
end

def delete_item(key)
  db = Redic.new
  db.call("DEL", key)
  db.quit
end

def clip_board_copy(key)
  Clipboard.copy(read_from_db(key).get_password)
end


